# Song

## convert

```bash
siren song convert FILE
```

Convert a song to a set of Kubernetes resource descriptions.

Until Kubernetes is fully integrated into the CLI, you could deploy a song on a Kubernetes cluster using the command:

```bash
siren song convert FILE | kubectl apply -f -
```

and remove it with

```bash
siren song convert FILE | kubectl delete -f -
```

Or, you can save the resources to a file to edit or inspect them before deployment.

## File format

```yaml
# Choff for Kubernetes.
apiVersion: siren.altaire.xyz/v1
kind: Song
metadata:
  # A name is required.
  name: builder
spec:
  # Global environmental variables which apply to all services.
  env:
    name: value
  service:
  - # As you can imagine, the image to run.
    image: altaire/builder-live
    # Optionally, the command to run in the image.
    command: command-name
    # Optionally, name this service.
    # If there are multiple services, you _must_ name them.
    name: service-name
    # Environmental variables which apply to all services.
    # These override the global variables, if there are any.
    env:
      name: value
    # Publish the service one or more domains
    publish:
    - # The port the service is listening on.
      port: 8081
      # Expose this port on a dedicated load balancer.
      # If unset, expose the port via Traefik.
      loadBalancer: lb-name
      # Domain name to use.
      domain: builder.k9.altaire.xyz
      # Use built-in Altaire auth.
      auth: true
  - ...
```
